Attribute VB_Name = "ZipNo"
Option Explicit

#If Win64 Then
    Dim dbHandle As LongPtr
    Dim stmtHandle As LongPtr
#Else
    Dim dbHandle As Long
    Dim stmtHandle As Long
#End If

Sub TestZipAddr()
    Debug.Print Zip2Addr("1050011")
    Debug.Print Zip2Addr("6008213")
    Call ZipClose
End Sub

Public Function ZipInit() As Boolean
    ' --- SQLitȅ ---
    Dim InitReturn As Long
    #If Win64 Then
        ' I put the 64-bit version of SQLite.dll under a subdirectory called x64
        InitReturn = SQLite3Initialize(ThisWorkbook.Path + "\lib\x64")
    #Else
        InitReturn = SQLite3Initialize(ThisWorkbook.Path + "\lib") ' Default path is ThisWorkbook.Path but can specify other path where the .dlls reside.
    #End If
    If InitReturn <> SQLITE_INIT_OK Then
        Debug.Print "Error Initializing SQLite. Error: " & Err.LastDllError
        ZipInit = False
        Exit Function
    End If
    dbHandle = 0
    ZipInit = True
End Function

Public Sub ZipOpen()
    ' SQLiteDBJ
    Dim RetVal As Long
    Dim dbfile As String
    ' DB̎w
    dbfile = ThisWorkbook.Path & "\lib\zip.sqlite3"
    ' J
    RetVal = SQLite3OpenV2(dbfile, dbHandle, SQLITE_OPEN_READONLY, "")
    If RetVal <> 0 Then
        Debug.Print "Error Open DB:" & dbfile
    End If
End Sub

Public Sub ZipClose()
    Call SQLite3Close(dbHandle)
    dbHandle = 0
    stmtHandle = 0
End Sub


Public Function Zip2Addr(zipno As String) As String
    ' SQLiteDBJ
    Dim RetVal As Long
    If dbHandle = 0 Then
        Call ZipInit
        Call ZipOpen
    End If
    
    ' SQLiteDB
    Dim sql As String
    Dim ken As String, shi As String, cho As String
    ' SQLw
    zipno = Replace(zipno, "-", "")
    sql = "SELECT * FROM zip WHERE zipno=""" & zipno & """"
    ' 
    RetVal = SQLite3PrepareV2(dbHandle, sql, stmtHandle)
    ' o
    RetVal = SQLite3Step(stmtHandle)
    If RetVal = SQLITE_ROW Then
        ken = SQLite3ColumnText(stmtHandle, 1)
        shi = SQLite3ColumnText(stmtHandle, 2)
        cho = SQLite3ColumnText(stmtHandle, 3)
        Zip2Addr = ken & shi & cho
    Else
        Debug.Print "Error:" & RetVal
        Zip2Addr = ""
    End If
    ' 
    RetVal = SQLite3Finalize(stmtHandle)
End Function



